;============================================================
;macros for main initialization code
;=========================================================

MACRO _WRITE_EXE dest_addr,source_addr,num_bytes,errormessage {
      local faillabel
	sub esp,4
	mov ecx,esp
invoke WriteProcessMemory,ebx,dest_addr,source_addr,num_bytes,ecx
	pop ecx
	mov edx,1
	test eax,eax
	jz faillabel
	cmp ecx,num_bytes
	jnz faillabel
	xor edx,edx
	faillabel:
	WRITELOG errormessage,edx
}

;=========================================================

MACRO _WRITE_EXE_2 dest_addr,source_addr,num_bytes {
      local faillabel
	sub esp,4
	mov ecx,esp
invoke WriteProcessMemory,ebx,dest_addr,source_addr,num_bytes,ecx
	pop ecx
}

;=========================================================

MACRO _SET_DWORD_VAR dest,source {
local NoSetVar,nofaillabel
mov ebp,2
cmp DWORD [source],0
jz NoSetVar
	sub esp,4
	mov ecx,esp
invoke WriteProcessMemory,ebx,dest,source,4,ecx
	pop ecx
	xor ebp,ebp
	test eax,eax
	jnz nofaillabel
	cmp ecx,4
	jz nofaillabel
	or ebp,1
	nofaillabel:
NoSetVar:
}

;=========================================================
;FOR INIT_INI.inc ONLY
MACRO SKIP_SPACE_INI reg {
local SkipSpaceLoop
SkipSpaceLoop:
inc reg
	cmp reg,ebx			;EOF?
	ja EOF_INI
mov al,[reg]
cmp al,09h		;TAB
jz SkipSpaceLoop
cmp al,20h		;SPACE
jz SkipSpaceLoop
cmp al,';'
jz WaitForEndOfLine_INI
}

;=========================================================
;the following are macros used non-strictfully during
;error checking/logging
;=========================================================
MACRO WRITELOG _string,_failbool {
	or [DLLLoadSuccessBool],_failbool
	push _failbool
	push _string
	call WriteLogFile
	}

MACRO WRITELOG_NOFAIL _string,_failbool {
	push _failbool
	push _string
	call WriteLogFile
	}

MACRO WRITELOG_WEXIT _string {
	or [DLLLoadSuccessBool],ebp
	push ebp
	push _string
	call WriteLogFile
	cmp ebp,1
	jz ExitInit
	}

MACRO WRITELOG_NOEXIT _string {
	or [DLLLoadSuccessBool],ebp
	push ebp
	push _string
	call WriteLogFile
	}

