;============================================================
;Checks current level file and compares to entries in INI file.
;============================================================
;NEW: also includes CAnimal instance modification code
;Loads if same file name found.

;[ebp-4] = file handle
;[ebp-8] = file mapping handle (if used/not saved game)
;[ebp-12] = map view of file handle / address to INI file (if used)
;[ebp-16] = address of level name string (in EXE)
;ebx = EOF marker

LOADINITIALBITMAP:	;called after calls near "Finished Loading!" string
			;reference
push ebp
mov ebp,esp
sub esp,16
push ebx
push ecx
push edx
push esi
push edi
push eax

call ModifyCAnimalInstances
mov [CounterFirstRun],1
mov [NewLevel_BOOL],1

mov esi,[BaseData]

mov DWORD [ebp-4],0
mov DWORD [ebp-8],0
mov DWORD [ebp-12],0
;================================================================
mov esi,[LEVELNAME_OBJ] 	;(esi points to level SCN name)
add esi,20			;(esi points to savegame/scn file name and path)
mov edi,SAVEGAMENAME_BUFFER	;PATH+NAME OF CURRENT LEVEL FILE COPY (OR SAVEGAME)
	MOVELEVELGAMENAMELOOP:
	mov al,[esi]
	mov [edi],al
	test al,al
	jz ENDMOVELEVELGAMENAMELOOP
	inc esi
	inc edi
	jmp MOVELEVELGAMENAMELOOP
ENDMOVELEVELGAMENAMELOOP:
sub edi,3
cmp DWORD [edi],004E4353h	;'SCN',0
jz STANDARD_SCN_FILE
cmp DWORD [edi],006E6373h	;'scn',0
jz STANDARD_SCN_FILE

;================================================================
;------------- assume it is otherwise a saved game
;================================================================
	mov DWORD [edi-5],'DMAP'	;save as 'SAVEDMAP.xxx'

invoke CreateFile,SAVEGAMENAME_BUFFER,GENERIC_READ,0,0,\
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	test eax,eax
	jz SAVED_FILE_LOAD_FAIL
	cmp eax,-1
	jz SAVED_FILE_LOAD_FAIL
	mov [ebp-4],eax

invoke GetFileSize,eax,0
	cmp eax,-1
	jz SAVED_FILE_LOAD_FAIL
	cmp eax,21		;at least 4 32-bit floats + 'x.bmp'
	jb SAVED_FILE_LOAD_FAIL

invoke SetFilePointer,DWORD [ebp-4],0,0,FILE_BEGIN
	cmp eax,-1
	jz SAVED_FILE_LOAD_FAIL

	lea eax,[ebp-8] 	;read 4 POSITION float values and store
invoke ReadFile,DWORD [ebp-4],SAVED_MAP_X1,16,eax,0
	test eax,eax
	jz SAVED_FILE_LOAD_FAIL
	cmp DWORD [ebp-8],16
	jnz SAVED_FILE_LOAD_FAIL

	lea eax,[ebp-8] 	;read BITMAP name and store
invoke ReadFile,DWORD [ebp-4],SAVED_MAP_BUFFER,80,eax,0
	test eax,eax
	jz SAVED_FILE_LOAD_FAIL

;================================================================
;----------------- LOAD BITMAP FROM SAVED INDEX
;================================================================
	mov ecx,SAVED_MAP_OBJECT
	call AT102MAIN
	test eax,eax		;if load fails, use level's originally indexed map
	jz NoCloseHandle2_LOADBMP	;(jumps if success)

SAVED_FILE_LOAD_FAIL:
_CLOSEHANDLE DWORD [ebp-4]

;================================================================
STANDARD_SCN_FILE:
;================================================================
	mov DWORD [ebp-4],0
	mov DWORD [ebp-8],0
	mov DWORD [ebp-12],0

	mov edi,MapsDirBuffer
	add edi,[MapsPathSize]
	mov esi,MapIndex		 ;INI filename
    AppendBMPNameLoop_LOADBMP:
	mov al,[esi]
	mov [edi],al		 ;transfer/append string
	test al,al
	jz EndAppendBMPNameLoop_LOADBMP
	inc edi
	inc esi
	jmp AppendBMPNameLoop_LOADBMP
EndAppendBMPNameLoop_LOADBMP:
	mov esi,[BaseData]
;================================================================
;---------------- open MapIndex.ini file
;================================================================
invoke CreateFile,MapsDirBuffer,GENERIC_READ,0,0,OPEN_EXISTING,\
			FILE_ATTRIBUTE_NORMAL,0
	mov ecx,[MapsPathSize]
	mov BYTE [ecx+MapsDirBuffer],0	   ;restore path's null-terminator
	test eax,eax
	jz NEW_BITMAP_LOAD_FAIL
	cmp eax,-1
	jz NEW_BITMAP_LOAD_FAIL
	mov [ebp-4],eax

invoke GetFileSize,eax,0
       cmp eax,20
       jb NEW_BITMAP_LOAD_FAIL
       cmp eax,-1
       jz NEW_BITMAP_LOAD_FAIL
       mov ebx,eax

invoke CreateFileMapping,DWORD [ebp-4],0,PAGE_READONLY,0,0,0
	test eax,eax
	jz NEW_BITMAP_LOAD_FAIL
	mov [ebp-8],eax

invoke MapViewOfFile,eax,FILE_MAP_READ,0,0,0
	test eax,eax
	jz NEW_BITMAP_LOAD_FAIL
	mov [ebp-12],eax

;================================================================
;scan for bitmap name; if found, scan for X/Y position values
;================================================================
	mov edx,[LEVELNAME_OBJ] ;addr of level name string
	mov [ebp-16],edx
	mov edi,eax		;edi will hold INI address in mem
	dec edi
	add ebx,edi	;EOF

ScanForLVLoop_LOADBMP:

SCANFOR 'LV="'		;includes loop for [LV="] string

    mov edx,[ebp-16]
    ScanLevelNameLoop_LOADBMP:		;scans strings for = level name
    mov cl,[edi]
    mov al,[edx]
	CHAR_TOLOWERCASE cl
	CHAR_TOLOWERCASE al
	cmp al,0
	jz EndLevelName_LOADBMP
    cmp cl,al
    jnz ScanForLVLoop_LOADBMP
	inc edi
	inc edx
	cmp edi,ebx
	jnb NEW_BITMAP_LOAD_FAIL
    jmp ScanLevelNameLoop_LOADBMP
EndLevelName_LOADBMP:
	cmp cl,'"'
	jnz ScanForLVLoop_LOADBMP

;================================================================
;---------- level name found -----------
;================================================================

SCANFOR 'BM="'
	mov [AT102EMULATEDOBJECT+8],edi 	;save bitmap name
SCANFOR '_X1='
	invoke sscanf,edi,_float,AT102EMULATEDOBJECT+12
	add esp,12
SCANFOR '_Y1='
	invoke sscanf,edi,_float,AT102EMULATEDOBJECT+16
	add esp,12
SCANFOR '_X2='
	invoke sscanf,edi,_float,AT102EMULATEDOBJECT+20
	add esp,12
SCANFOR '_Y2='
	invoke sscanf,edi,_float,AT102EMULATEDOBJECT+24
	add esp,12

;================================================================
;------ Load new bitmap (if not saved game)
;================================================================
	mov ecx,AT102EMULATEDOBJECT
	call AT102MAIN	 ;emulates a normal AT102 call to load file
;================================================================
NEW_BITMAP_LOAD_FAIL:
	mov eax,[ebp-12]
	test eax,eax
	jz NoUnmapViewOfFile_LOADBMP
	invoke UnmapViewOfFile,eax
	NoUnmapViewOfFile_LOADBMP:
_CLOSEHANDLE DWORD [ebp-8]
NoCloseHandle2_LOADBMP:
_CLOSEHANDLE DWORD [ebp-4]

pop eax
pop edi
pop esi
pop edx
pop ecx
pop ebx
mov esp,ebp
pop ebp

	  ;REPLACED CODE HERE
	  add esp,604h+4
	  jmp DWORD [esp-(604h+4)]



